--[[
  Author: Atrophenus
  Version: 1.0.0
  Description: Sends a custom hail based on what nation your character is and if your target is an enemey, neutral, or an ally to said nation
  
  Set-Up:
    Simply replace Hail! in the quotation marks below with whatever message you want sent based on your character's nation
    from there to use the user commands are:
      /combathail
      /enemyhail
      /neutralhail
      /allyhail
  --]]

CombatHail = {}
CombatHailVar = {}

-- Replace Hail! with whatever message you would like to send based on your characters nation
-- The message you send if your character is Itani
CombatHailVar.ITANIenemymsg = "Hail!"
CombatHailVar.ITANIneutralmsg = "Hail!"
CombatHailVar.ITANIallymsg = "Hail!"

-- The message you send if your character is Serco
CombatHailVar.SERCOenemymsg = "Hail!"
CombatHailVar.SERCOneutralmsg = "Hail!"
CombatHailVar.SERCOallymsg = "Hail!"

-- The message you send if your character is UIT
CombatHailVar.UITenemymsg = "Hail!"
CombatHailVar.UITneutralmsg = "Hail!"
CombatHailVar.UITallymsg = "Hail!"



-- DO NOT CHANGE THESE VARIABLES
CombatHailVar.relation = 0

CombatHailVar.enemymsg = "enemy"
CombatHailVar.neutralmsg = "neutral"
CombatHailVar.allymsg = "ally"

CombatHailVar.selfname = ""
CombatHailVar.selfcharid = 0
CombatHailVar.selffactionid = 0

--Writes over the enemy msg variables with the custom ones based on your character's nation
function CombatHailVar.msgloader()
  if CombatHailVar.selffactionid == 1 then
    CombatHailVar.enemymsg = CombatHailVar.ITANIenemymsg
    CombatHailVar.neutralmsg = CombatHailVar.ITANIneutralmsg
    CombatHailVar.allymsg = CombatHailVar.ITANIallymsg
  elseif CombatHailVar.selffactionid == 2 then
    CombatHailVar.enemymsg = CombatHailVar.SERCOenemymsg
    CombatHailVar.neutralmsg = CombatHailVar.SERCOneutralmsg
    CombatHailVar.allymsg = CombatHailVar.SERCOallymsg
  elseif CombatHailVar.selffactionid == 3 then
    CombatHailVar.enemymsg = CombatHailVar.UITenemymsg
    CombatHailVar.neutralmsg = CombatHailVar.UITneutralmsg
    CombatHailVar.allymsg = CombatHailVar.UITallymsg
  else
    CombatHailVar.enemymsg = 'enemy error'
    CombatHailVar.neutralmsg = 'neutral error'
    CombatHailVar.allymsg = 'ally error'
  end   
end

-- Checks if the person you are hailing is respected or higher, neutral, or disliked or lower to send the appropriate message
function CombatHailVar.standingcheck(SelfFactionID, TargetCharID)
  local standing = GetPlayerFactionStanding(SelfFactionID, TargetCharID)
    if standing <= 26214 then
      CombatHailVar.relation = 1
      return CombatHailVar.relation
    elseif standing <= 39321 then
      CombatHailVar.relation = 2
      return CombatHailVar.relation
    else 
      CombatHailVar.relation = 3
      return CombatHailVar.relation
    end
end

--Sends the hail based on what the target's standing with your nation is
function CombatHail.combathail()
    local name, health, distance, factionid, guild, ship = GetTargetInfo();
    CombatHailVar.selfname = GetPlayerName();
    CombatHailVar.selfcharid = GetCharacterIDByName(CombatHailVar.selfname);
    CombatHailVar.selffactionid = tonumber(GetPlayerFaction(CombatHailVar.selfcharid));

    CombatHailVar.msgloader();
    if name ~= nil then
      if health ~=nil then 
        local targetcharid = GetCharacterIDByName(name)
        CombatHailVar.standingcheck(CombatHailVar.selffactionid, targetcharid)
        if CombatHailVar.relation == 1 then
          local msg = CombatHailVar.enemymsg
          SendChat(msg, "PRIVATE", name)
        elseif CombatHailVar.relation == 2 then
          local msg = CombatHailVar.neutralmsg
          SendChat(msg, "PRIVATE", name)
        elseif CombatHailVar.relation == 3 then
          local msg = CombatHailVar.allymsg
          SendChat(msg, "PRIVATE", name)

        end
      end
    end
end

--Allows you to send the enemy hail manually
function CombatHail.enemyhail()
  local name, health, distance, factionid, guild, ship = GetTargetInfo();
  CombatHailVar.selfname = GetPlayerName();
  CombatHailVar.selfcharid = GetCharacterIDByName(CombatHailVar.selfname);
  CombatHailVar.selffactionid = tonumber(GetPlayerFaction(CombatHailVar.selfcharid));

  CombatHailVar.msgloader();
  if name ~= nil then
    if health ~= nil then
      local msg = CombatHailVar.enemymsg
      SendChat(msg, "PRIVATE", name)
    
    end
  end
end

--Allows you to send the neutral hail manually
function CombatHail.neutralhail()
  local name, health, distance, factionid, guild, ship = GetTargetInfo();
  CombatHailVar.selfname = GetPlayerName();
  CombatHailVar.selfcharid = GetCharacterIDByName(CombatHailVar.selfname);
  CombatHailVar.selffactionid = tonumber(GetPlayerFaction(CombatHailVar.selfcharid));

  CombatHailVar.msgloader();
  if name ~= nil then
    if health ~= nil then
      local msg = CombatHailVar.neutralmsg
      SendChat(msg, "PRIVATE", name)
    
    end
  end
end

--Allows you to send the ally hail manually
function CombatHail.allyhail()
  local name, health, distance, factionid, guild, ship = GetTargetInfo();
  CombatHailVar.selfname = GetPlayerName();
  CombatHailVar.selfcharid = GetCharacterIDByName(CombatHailVar.selfname);
  CombatHailVar.selffactionid = tonumber(GetPlayerFaction(CombatHailVar.selfcharid));

  CombatHailVar.msgloader();
  if name ~= nil then
    if health ~= nil then
      local msg = CombatHailVar.allymsg
      SendChat(msg, "PRIVATE", name)
    
    end
  end
end

RegisterUserCommand("combathail", CombatHail.combathail)
RegisterUserCommand("enemyhail", CombatHail.enemyhail)
RegisterUserCommand("neutralhail", CombatHail.neutralhail)
RegisterUserCommand("allyhail", CombatHail.allyhail)